  'Debug.Str(string(""))
  'Debug.Str(string("",13))
  'Debug.Dec()
  'Debug.Rx()
  'Debug.Tx()

CON
  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000

  'defining constants makes code selfexplaining
  'see line with Debug.Start(.... 
  DebugTx_Pin = 30
  DebugRx_Pin = 31
  Baudrate    = 115200
  FDX_Mode    = 0  

  
VAR
  long received_Char

  
OBJ
  Debug   : "FullDuplexSerial"

  
PUB Main
  StartSerialDebugging

  received_Char := -1

  repeat until received_Char <> -1 
    received_Char := debug.rxtime(1000)
    if received_Char == -1
      Debug.Str(string("type any kind of a letter or number key like abc or 123",13))
      Debug.Str(string("the pressed key is echoed back to PST.EXE ",13,13))

  debug.tx(received_Char)
  repeat
    received_Char := debug.rx
    debug.tx(received_Char)

    
Pub StartSerialDebugging
  Debug.Start(DebugRx_Pin,DebugTx_Pin,FDX_Mode,Baudrate)

  Debug.Str(string("FullDuplexSerialPlus-Driver started with ",13))
  Debug.Str(string("Start(DebugRx_Pin="))
  Debug.Dec(DebugRx_Pin)
  Debug.Str(string(",DebugTx_Pin="))
  Debug.Dec(DebugTx_Pin)
  Debug.Str(string(",FDX_Mode="))
  Debug.Dec(FDX_Mode)
  Debug.Str(string(",Baudrate="))
  Debug.Dec(Baudrate)
  Debug.Str(string(13,13))

  